<?php
require_once("Profile.php");
require_once("Federation.php");
require_once("DeviceFactory.php");
require_once("devices/devices.php");

class GUI {

  public function generateInstaller($template,$prof_id) {
    debug(4,"installer:$template:$prof_id\n");
    $profile = new Profile($prof_id);
    $a = array();
    $factory = new DeviceFactory($template);
    $dev = $factory->device;
    $a['profile'] = $prof_id;
    $a['system'] = $template;
    if(isset($dev)) {
       $dev->setup($profile);
       $a['link'] = $dev->FPATH.'/'.$dev->writeInstaller($profile);
    } 
    return($a);
 }

 public function profileAttributes($prof_id) {
      $profile = new Profile($prof_id);
      $attr = $profile->getCollapsedAttributes();
      $a = array();
      if(isset($attr['support:email']))
         $a['local_email'] = $attr['support:email'][0];
      if(isset($attr['support:phone']))
         $a['local_phone'] = $attr['support:phone'][0];
      if(isset($attr['support:url']))
         $a['local_url'] = $attr['support:url'][0];
      return($a);
 }

}
class JSON {

  public function listIdentityProvidersForDisco() {
     $idps = Federation::listAllIdentityProviders();
     echo json_encode($idps);
  }

  public function listProfiles($idp_id) {
     $idp = new IdP($idp_id);
     $profiles = $idp->listProfiles();
     echo json_encode($profiles);
  }
  
  public function generateInstaller($template,$prof_id) {
    debug(4,"JSON::generateInstaller arguments: $template,$prof_id\n");
    $o = GUI::generateInstaller($template,$prof_id);
    debug(4,"output from GUI::generateInstaller:");
    debug(4,$o);
    debug(4,json_encode($o));
    echo json_encode($o);
 }

  public function profileAttributes($prof_id) {
    echo json_encode(GUI::profileAttributes($prof_id));
  }

}
?>
