<?php
/**
 * This file contains a random assortment of useful functions and classes.
 * @author Stefan Winter <stefan.winter@restena.lu>
 * @author Tomasz Wolniewicz <twoln@umk.pl>
 *
 * @package Developer
 */

require_once('DBConnection.php');

function error($t) {
    print ("$t\n");
}

function debug($level,$t) {
    if ( Config::$DEBUG_LEVEL >= $level ) {
        ob_start();
        print "($level) ";
        print_r($t);
        $output = ob_get_clean();
        if( Config::$DEBUG_FILE) {
            $f = fopen(Config::$DEBUG_FILE,"a");
            fwrite($f,$output);
            fclose($f);
        } else {
            print $output;
        }
    }
}

function fetch_raw_db_data($table, $row) {
    DBConnection::handle();

    $q = "SELECT option_value from $table WHERE row = $row";
    $blob_query = mysql_query($q);
    while ($a = mysql_fetch_object($blob_query))
        $blob = $a->option_value;

    if (!isset($blob)) return FALSE;
    return $blob;
}

function description($input) {
    $Desriptions = array ( "Support web page where your users can learn how to configure and use eduroam" => "local_url",
            "Support web page for specific EAP types" => "local_support",
            "Support phone number which your users can call if they need help" => "local_email"
    );

    $find = array_search($input,$Descriptions);

    if ( $find === FALSE ) {
        return $input;
    }
    else {
        return $find;
    }

}

function availableOptions($class_name = 0) {

    DBConnection::handle();

    $q = "SELECT name from profile_option_dict".( $class_name ? " WHERE name LIKE '".$class_name."%'" : "");
    $options = mysql_query($q);

    $returnarray = array();

    while($a = mysql_fetch_object($options))
        $returnarray[] = $a->name;

    if ($class_name == "general") $returnarray[] = "general:logo_url";
    if ($class_name == "eap") $returnarray[] = "eap:ca_url";

    return $returnarray;
}

function EAPMethodIdFromArray($method_array) {
    $q = "SELECT eap_method_id FROM eap_method WHERE php_serialized = '".serialize($method_array)."'";

    $exec_q = mysql_query($q);

    while ($a = mysql_fetch_object($exec_q))
        return $a->eap_method_id;
    return FALSE;
}

function calculateCommonHostSuffix(array $hosts) {
    // massage names. A trailing dot can be omitted
    foreach ($hosts as $index => $host)
    if (substr($host,-1) == '.') {
        $hosts[$index] = substr($host,0,-1);
        echo "Changed host to ".$hosts[$index]."\n";
    }
    // easy :-)
    if (count($hosts) == 1) return $hosts[0];
    // not so easy :-(
    else {
        // look for the last dot from the end; if the corresponding substring is
        // different, no common match!
        $explodednames = array();
        foreach ($hosts as $host)
            $explodednames[] = explode('.',$host);
        $commonsuffix = array();
        while (count($explodednames[0]) > 0) {
            $match = TRUE;
            $testname = array_pop($explodednames[0]);            
            for ($i = 1; $i < count($explodednames); $i=$i+1) {            
                if (count($explodednames[$i]) == 0) $match = FALSE;            
                $bla = array_pop($explodednames[$i]);            
                if ($bla != $testname) $match = FALSE;            
            }            
            if ($match == TRUE)
                $commonsuffix[] = $testname;            
            else
                break;
        }
        $finalsuffix = array_reverse($commonsuffix);
        return implode('.',$finalsuffix);
    }
}

function downloadFile ($url) {
    $cadata;
    if (preg_match("/:\/\//", $url)) {
        # we got a URL, download it
        $download = fopen($url,"rb");
        $cadata = stream_get_contents($download);
        if(! $cadata )
            error("Failed to download the file form $url");
        return($cadata);
    } else {
        error("The specified string does not seem to be a URL!");
    }
}

/**
 * generates a UUID
 *
 * @param string $prefix an extra prefix to set before the UUID
 * @return UUID (possibly prefixed)
 */
function uuid($prefix = '') {
    $chars = md5(uniqid(mt_rand(), true));
    $uuid  = substr($chars,0,8) . '-';
    $uuid .= substr($chars,8,4) . '-';
    $uuid .= substr($chars,12,4) . '-';
    $uuid .= substr($chars,16,4) . '-';
    $uuid .= substr($chars,20,12);
    return $prefix . $uuid;
}

function set_locale($domain, $hardsetlocale = 0) {
    debug(4,"set_locale($domain, $hardsetlocale)\n");
    set_lang($hardsetlocale);
    putenv("LC_ALL=Globals::$thelang");
    setlocale(LC_ALL, Globals::$thelang);
    $b = textdomain($domain);
    $a = bindtextdomain($domain, dirname(Globals::$root)."/translation/");
    Globals::$thedomain = $domain;
    debug(4,"set locale: ".Globals::$lang_index.": ".Globals::$thelang.": ".Globals::$thedomain."\n");
    return  Globals::$lang_index;
}

function set_lang($hardsetlocale = 0) {
    $lang_converted = array();
    if($hardsetlocale !== 0 )
       $lang_converted[] = $hardsetlocale;
    else { 
    if(isset($_REQUEST['lang'])) {
       $hardsetlocale = $_REQUEST['lang'];
       $lang_converted[] = $hardsetlocale;
    } elseif (isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
        $langs = explode(",",$_SERVER["HTTP_ACCEPT_LANGUAGE"]);
        foreach ($langs as $lang) {
            preg_match("/(.*);+.*/", $lang, $result);
            $lang_converted[] = ($result[1] ? $result[1] : $lang);
        }
    }};
    // always add configured locale as last resort
    $lang_converted[] = Config::$DEFAULT_LOCALE['locale'];
    $lang_index = Config::$DEFAULT_LOCALE['lang_index'];
 
    $old_locale = setlocale(LC_ALL,0);

    foreach ($lang_converted as $try_lang) {
        // madness! setlocale is completely unflexible. If $try_lang is "en"
        // it will fail, because it only knows en_US, en_GB a.s.o.
        // we need to map stuff manually
        $thelang = $try_lang;
        
        foreach (Config::$LANGUAGES as $language => $value)
        if (preg_match("/^".$language.".*/", $try_lang)) {
            $thelang = $value['locale'];
            $lang_index = $language;
        }

        // echo "Trying to set language to $thelang...";
//        putenv("LC_ALL=$thelang");
        if (setlocale(LC_ALL, $thelang)) break;
    }
    //restore old locale;
    setlocale(LC_ALL,$old_locale);

    Globals::$lang_index = $lang_index;
    Globals::$thelang = $thelang;
    debug(4,"selected lang:$lang_index\n");
    debug(4,$lang_converted);
    return $lang_index;
}
/**
  * Define some variables which need to be globally accessible
  *
 */
class Globals {
/**
 * Current gettext domain set by set_locale()
 * @var string 
 */
public static $thedomain;
/**
 * Current language setting (en, de, pl, etc.)
 * @var string 
 */
public static $lang_index;
/**
 * Current language name
 * @var string 
 */
public static $thelang;
/**
 * CAT source location
 * @var string 
 */
public static $root = __DIR__;
}

?>
