<?php
require_once(dirname(dirname(dirname(__FILE__)))."/config/_config.php");
include_once("Federation.php");
include_once("IdP.php");
include_once("Helper.php");
include_once("inc/common.inc.php");

if (isset($_GET['lang'])) {
    $ourlocale = set_locale("web_admin",$_GET['lang']);
    $lang_string = "&lang=".$_GET['lang'];
}
else {
    $ourlocale = set_locale("web_admin");
    $lang_string="";
}

// let's check if the inst handle actually exists in the DB

$my_inst = new IdP($_GET['inst_id']);

if (! $my_inst instanceof IdP) {
    echo "<p>"._("The page was called with a non-existing IdP identifier. This is not supposed to happen!")."</p>";
    exit(1);
}

// how do we determine if we should go into wizard mode? Well if there are no options
// whatsoever, assume this is new.

$idpoptions = $my_inst->getAttributes();

if (isset($_GET['wizard']) && $_GET['wizard'] == "true") {
    $wizard_style = TRUE;
    $edit_mode = FALSE;
} else {
    $wizard_style = FALSE;
    $edit_mode = TRUE;
}

if (isset( $_POST['submitbutton']) && $_POST['submitbutton'] == 'deleteidp' ) {
    // delete the IdP and send user to enrollment
    $my_inst->destroy();
    header("Location:enrollment.php");
}

header("Content-Type:text/html;charset=utf-8");
?>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <meta http-equiv="content-language" content="<?php echo $ourlocale;?>">
        <title><?php printf(_("IdP enrollment wizard (step 2 completed)"),Config::$PRODUCT_NAME); ?>: </title>
        <link rel="stylesheet" type="text/css" href="../resources/css/cat.css" />
    </head>
    <body>
        <?php
        include "inc/admin_header.php";
        if (isset( $_POST['submitbutton'])) {
            if ( ( $_POST['submitbutton'] == 'save' || $_POST['submitbutton'] == 'continue') && isset( $_POST['option']) && isset ($_POST['value']) ) { // here we go
                echo "<h1>".sprintf(_("Submitted attributes for IdP '%s'"),$my_inst->name)."</h1>";
                $remaining_attribs = $my_inst->beginflushAttributes();

                $killlist = processSubmittedFields($my_inst,$remaining_attribs);

                // print_r($killlist);
                $my_inst->commitFlushAttributes($killlist);

                if ($_POST['submitbutton'] == "save")
                    echo "<br/><form method='post' action='dashboard.php?inst_id=$my_inst->identifier$lang_string'><button type='submit'>"._("Continue to dashboard")."</button></form>";
                else if ($_POST['submitbutton'] == "continue")
                    echo "<br/><form method='post' action='profile_wizard.php?inst_id=$my_inst->identifier$lang_string'><button type='submit'>"._("Continue to profile definition")."</button></form>";
            }
        }
        include "inc/admin_footer.php"; ?>
    </body>
</html>
