<?php

require_once(dirname(dirname(dirname(dirname(__FILE__))))."/config/_config.php");
include_once("IdP.php");
include_once("Profile.php");
include_once("Helper.php");
include_once("devices/devices.php");
include_once("common.inc.php");

if (isset($_GET['lang'])) {
    $ourlocale = set_locale("web_admin",$_GET['lang']);
    $lang_string = "&lang=".$_GET['lang'];
}
else {
    $ourlocale = set_locale("web_admin");
    $lang_string="";
}

header("Content-Type:text/html;charset=utf-8");
$my_inst = new IdP($_GET['inst_id']);

if (! $my_inst instanceof IdP) {
    echo "<p>"._("The page was called with a non-existing IdP identifier. This is not supposed to happen!")."</p>";
    exit(1);
}

$my_profile = new Profile($_GET['profile_id']);

if (! $my_profile instanceof Profile) {
    echo "<p>"._("The page was called with a non-existing profile identifier. This is not supposed to happen!")."</p>";
    exit(1);
}

$devices = Devices::listDevices();

$eaptype = unserialize(stripslashes($_POST['eaptype']));
$device = $devices[$_POST['device']];

// if we have a pushed button, execute the action and send user back to the compat matrix

if (isset($_POST['buttonvalue'])) {
    if ($_POST['buttonvalue'] == 'enableredirect') {
        $my_profile->registerBlacklist($_POST['target'], $eaptype, $device['module']);
        header("Location: ../compatibility_matrix.php?inst_id=$my_inst->identifier&profile_id=$my_profile->identifier$lang_string");
    }
    if ($_POST['buttonvalue'] == 'cancelredirect') {
        $my_profile->unregisterBlacklist($eaptype, $device['module']);
        header("Location: ../compatibility_matrix.php?inst_id=$my_inst->identifier&profile_id=$my_profile->identifier$lang_string");
    }
}

$blacklisttarget = $my_profile->isBlacklisted($eaptype, $device['module']);

echo "<p>".sprintf(_("EAP type <strong>%s</strong> on device <strong>%s</strong>"),display_name($eaptype),$device['display'])."</p><hr/>";

if ($blacklisttarget) {
    echo "<p>".sprintf(_("This combination of device/EAP type currently gets redirected to <a href='%s'>%s</a> ."),$blacklisttarget,$blacklisttarget)."</p>";
    echo "<form method='post' action='inc/toggleRedirect.inc.php?inst_id=$my_inst->identifier&profile_id=$my_profile->identifier$lang_string'><input type='hidden' name='eaptype' value='".$_POST['eaptype']."'/><input type='hidden' name='device' value='".$_POST['device']."'/><button type='submit' name='buttonvalue' value='cancelredirect'>"._("Cancel redirect")."</button></form>";
}
else {
    echo "<p>"._("This combination of device/EAP type currently gets displayed on CAT's download page.")."</p>";
    echo "<p><form method='post' action='inc/toggleRedirect.inc.php?inst_id=$my_inst->identifier&profile_id=$my_profile->identifier$lang_string'>Redirect users to URL: <input type='text' name='target'><input type='hidden' name='eaptype' value='".$_POST['eaptype']."'/><input type='hidden' name='device' value='".$_POST['device']."'/><button type='submit' name='buttonvalue' value='enableredirect'>"._("Enable redirect")."</button></form>";
}

?>
