<?php
include_once("inc/common.inc.php");
include_once("IdP.php");
include_once("Profile.php");

if (isset($_GET['lang'])) {
    $ourlocale = set_locale("web_admin",$_GET['lang']);
    $lang_string = "&lang=".$_GET['lang'];
}
else {
    $ourlocale = set_locale("web_admin");
    $lang_string="";
}

// let's check if the inst handle actually exists in the DB

$my_inst = new IdP($_GET['inst_id']);

if (! $my_inst instanceof IdP) {
    echo "<p>"._("The page was called with a non-existing IdP identifier. This is not supposed to happen!")."</p>";
    exit(1);
}

// check if profile exists and belongs to IdP

$edit_mode = FALSE;
$my_profile = FALSE;

if (isset($_GET['profile_id']) ) {
    $inst_profiles = $my_inst->listProfiles();
    foreach ($inst_profiles as $profile)
        if ($profile->identifier == $_GET['profile_id']) {
            $my_profile = $profile;
            $edit_mode = TRUE;
            break;
        }
    if ( $my_profile === FALSE) { // no profile <-> inst match!
        echo "<p>"._("The page was called with a Profile identifier, but there was no such profile in this institution!")."</p>";
        exit(1);
    }
}
// did the user submit info? If so, submit to DB and go on to the 'dashboard' or 'next profile' page.
// if not, what is he doing on this page anyway!

if ( isset( $_POST['submitbutton']) ) {

    $idpoptions = $my_inst->getAttributes();
    // maybe we were asked delete an existing profile? check for that...

    if ( $_POST['submitbutton'] == "deleteprofile" && $my_profile !== FALSE) {
        $my_profile->destroy();
        header("Location: dashboard.php?inst_id=$my_inst->identifier$lang_string");
    }

    if ($edit_mode) { // we need to write new data into an existing profile
        // i.e. flush/overwrite everything
        $profile = $my_profile;
        $profile->setName($_POST['profile_name']);
    }
    else {
        $profile = $my_inst->newProfile($_POST['profile_name']);
    }


    echo "<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv='Content-Type' content='text/html; charset=UTF-8'>
        <meta http-equiv='content-language' content='$ourlocale'>
        <title>";
    printf(_("%s: Profile wizard (step 3 completed)").Config::$PRODUCT_NAME);
    echo "</title>
        <link rel='stylesheet' type='text/css' href='../resources/css/cat.css' />
    </head>
    <body>";
    include "inc/admin_header.php";
    if (! $profile instanceof Profile) {
        echo _("Darn! Could not get a proper profile handle!");
        exit(1);
    };
    $profile->flushSupportedEapMethods();
    echo "<h1>".sprintf(_("Submitted attributes for Profile '%s'"),$profile->name)."</h1>";
    echo "<table>";
    foreach (EAP::listKnownEAPTypes() as $a) {
        if (isset($_POST[display_name($a)]) && isset($_POST[display_name($a)."-priority"]) && $_POST[display_name($a)."-priority"] != "") {
            $profile->addSupportedEapMethod($a, $_POST[display_name($a)."-priority"]);
            echo "<tr><td><img class='icon' src='../resources/images/icons/Checkmark-lg-icon.png' alt='"._("OK!")."' title='"._("OK!")."'/></td><td>"._("Supported EAP Type: ")."<strong>".display_name($a)."</strong></td></tr>";
        }
    }
    if (isset($_POST['realm'])) {
        $profile->setRealm($_POST['realm']);
        echo "<tr><td><img class='icon' src='../resources/images/icons/Checkmark-lg-icon.png' alt='"._("OK!")."' title='"._("OK!")."'/></td><td>".sprintf(_("Realm: <strong>%s</strong>"),$_POST['realm'])."</td></tr>";
    }
    echo "<tr><td><img class='icon' src='../resources/images/icons/Checkmark-lg-icon.png' alt='"._("OK!")."' title='"._("OK!")."'/></td><td>"._("Anonymous Identity support is ");
    if (isset($_POST['anon_support']) && $_POST['anon_support'] == "on" && isset($_POST['realm'])) {
        $profile->setAnonymousIDSupport(true, $_POST['realm']);
        echo "<strong>"._("ON")."</strong>";
    } else {
        $profile->setAnonymousIDSupport(false);
        echo "<strong>"._("OFF")."</strong>";
    };
    echo "</td></tr>";
    echo "</table>";

    $remaining_attribs = $profile->beginflushAttributes(0);
    $killlist = processSubmittedFields($profile,$remaining_attribs);
    $profile->commitFlushAttributes($killlist);
    if ( $_POST['submitbutton'] == "submitted-dashboard" )
        echo "<br/><form method='post' action='dashboard.php?inst_id=$my_inst->identifier$lang_string'><button type='submit'>"._("Continue to dashboard")."</button></form>";
    else if ( $_POST['submitbutton'] == "submitted-more" )
        echo "<br/><form method='post' action='profile_wizard.php?inst_id=$my_inst->identifier$lang_string'><button type='submit'>"._("Continue to next profile")."</button></form>";
}
?>
